import pandas as pd
from enums.DatabaseTypeEnum import DatabaseTypeEnum
from sqlalchemy.types import VARCHAR

import logging

logger = logging.getLogger()


def save_from_dataframe(df: pd.DataFrame, tablename: str, connection) -> bool:
    save = False
    try:
        chunksize = 2000
        # db_type = connection.db_type
        connection = connection.engine
        # print(df["CREACION_PRODUCTO"].value_counts())
        with connection.connect() as conn:
            # if db_type == DatabaseTypeEnum.ORACLE.value:
            #     df.info()
            #     aux = df.columns[df.dtypes == 'object'].tolist()
            #     print(aux)
            #     dtyp = {}
            #     for col in aux:
            #         print(col)
            #         print(df[col].dtype)
            #         df[col] = df[col].astype(str)
            #         dtyp.update({col: VARCHAR(df[col].str.len().max())})
            #     # dtyp = {c: VARCHAR(df[c].str.len().max()) for c in aux}
            #     print(dtyp)
            #     df.to_sql(tablename, conn, if_exists='append', dtype=dtyp, index=False, chunksize=chunksize)
            # else:
            df.to_sql(tablename, conn, if_exists='append', index=False, chunksize=chunksize)
            save = True
    except Exception as e:
        logger.error(f"Error guardando resultados desde dataframe. {e}")
        raise AssertionError(f"Error guardando resultados desde dataframe. {e}")
    finally:
        return save
